function varargout = IP(varargin)
% [ii jj] = IndexPair(ij) , ii>jj
% ij = IndexPair(ii, jj)

if nargin==1 && length(varargin{1})==1
    ij = varargin{1};
    iim1 = floor(sqrt(2*ij));
    ii = 1 + iim1;
    jj = ij - iim1*(iim1-1)/2;
    if jj>=ii
        ii = ii + 1;
        jj = ij - (ii-1)*(ii-2)/2;
    end
    if nargout==2
        varargout(1) = {ii};
        varargout(2) = {jj};
    elseif nargout==1
        varargout(1) = {[ii jj]};
    end
end

if nargin==2 || length(varargin{1})==2
    if nargin==2
        ii = varargin{1};
        jj = varargin{2};
    elseif length(varargin{1})==2
        ii = varargin{1}(1);
        jj = varargin{1}(2);
    end
    if ii<jj
        tmp=ii; ii=jj; jj=tmp;
    end
    ij = (ii-1)*(ii-2)/2 + jj;
    varargout(1) = {ij};
end
