function res = c(pi, diffOrd)
% pi is a column vector
% In the folllowing computation pi is assumed to have the form
% [y_start y1 y2 ... yN y_end]'
%     where y1 y2 ... yN are the only variables
% Returns: 1x1, 1xN or NxN
%
if nargin < 2
    diffOrd = 0;
end

% ------------------------------
clear global comp_c
global comp_c

% TODO: Change these
comp_c.a = 1;  % Weight on length cost
comp_c.b = 0.2;  % Weight on turn cost

comp_c.count = length(pi);
comp_c.y = pi;

comp_c.turn = 2*comp_c.y - [comp_c.y(2:end); comp_c.y(end)] - [comp_c.y(1); comp_c.y(1:end-1)];
comp_c.turnSq = comp_c.turn.^2;
% comp_c.turnMag = abs(comp_c.turn);
% for aa=1:length(comp_c.turn)
%     if comp_c.turnMag(aa) == 0
%         comp_c.turnSgn(aa) = 0;
%     else
%         comp_c.turnSgn(aa) = comp_c.turn(aa) / comp_c.turnMag(aa);
%     end
% end
% %comp_c.turn,
% %comp_c.turnSgn = comp_c.turn ./ comp_c.turnMag;
% %comp_c.turnSgn(isnan(comp_c.turnSgn)) = 0;

comp_c.dy = diff(pi);
comp_c.dySq = comp_c.dy.^2;
comp_c.MagSq = (1 + comp_c.dySq);
comp_c.Mag = sqrt(comp_c.MagSq);

% ------------------------------

if diffOrd == 0
    res = c0;
elseif diffOrd == 1
    res = c1;
    res = res(2:end);
elseif diffOrd == 2
    res = c2;
    res = res(2:end, 2:end);
end

% ========================================================

function res = c0
global comp_c
res = comp_c.a*sum(comp_c.Mag) + comp_c.b*sum(comp_c.turnSq(2:end-1)); %comp_c.b*sum(comp_c.turnMag(2:end-1));

% ------------------------------

function res = c1
global comp_c

for j = 2:comp_c.count-1
    res(j) = 0;
    res(j) = res(j) + comp_c.a*comp_c.dy(j-1)/comp_c.Mag(j-1);
    res(j) = res(j) - comp_c.a*comp_c.dy(j)/comp_c.Mag(j);
    res(j) = res(j) + 2*comp_c.b*(2*comp_c.turn(j) - comp_c.turn(j-1) - comp_c.turn(j+1)); %comp_c.b*(2*comp_c.turnSgn(j) - comp_c.turnSgn(j-1) - comp_c.turnSgn(j+1));
end

res = res';

% ------------------------------

function res = c2
global comp_c

for j = 2:comp_c.count-1
    for k = j:comp_c.count-1    % k >= j
        res(j,k) = 0;
        
        if j == k
            res(j,k) = res(j,k) + comp_c.a / (comp_c.Mag(j-1)*comp_c.MagSq(j-1)); %1/comp_c.Mag(j-1) - comp_c.dySq(j-1)/(comp_c.Mag(j-1)*comp_c.MagSq(j-1));
            res(j,k) = res(j,k) + comp_c.a / (comp_c.Mag(j)*comp_c.MagSq(j)); %1/comp_c.Mag(j) - comp_c.dySq(j)/(comp_c.Mag(j)*comp_c.MagSq(j));
            res(j,k) = res(j,k) + 12*comp_c.b;
        end
        
        if (k-j) == 1
            res(j,k) = -comp_c.a / (comp_c.Mag(j)*comp_c.MagSq(j));
            res(j,k) = res(j,k) - 8*comp_c.b;
        end
        
        res(k,j) = res(j,k);
    end
end

% ========================================================
